/**
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, v2.1.5-b01-fcs 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2008.07.15 at 04:13:34 PM PDT 
//


package org.apache.geronimo.components.jaspi.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import javax.security.auth.Subject;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.message.AuthException;
import javax.security.auth.message.AuthStatus;
import javax.security.auth.message.MessageInfo;
import javax.security.auth.message.config.ClientAuthContext;
import javax.security.auth.message.module.ClientAuthModule;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for clientAuthContextType complex type.
 * <p/>
 * <p>The following schema fragment specifies the expected content contained within this class.
 * <p/>
 * <pre>
 * &lt;complexType name="clientAuthContextType">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="messageLayer" type="{http://www.w3.org/2001/XMLSchema}string" minOccurs="0"/>
 *         &lt;element name="appContext" type="{http://www.w3.org/2001/XMLSchema}string" minOccurs="0"/>
 *         &lt;element name="authenticationContextID" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="clientAuthModule" type="{http://geronimo.apache.org/xml/ns/geronimo-jaspi}authModuleType" maxOccurs="unbounded" minOccurs="0"/>
 *       &lt;/sequence>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 *
 * @version $Rev: 939768 $ $Date: 2010-04-30 14:26:46 -0400 (Fri, 30 Apr 2010) $
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "clientAuthContextType", propOrder = {
        "messageLayer",
        "appContext",
        "authenticationContextID",
        "clientAuthModule"
        })
public class ClientAuthContextType
        implements Serializable, KeyedObject {

    private final static long serialVersionUID = 12343L;
    protected String messageLayer;
    protected String appContext;
    @XmlElement(required = true)
    protected String authenticationContextID;
    protected List<AuthModuleType<ClientAuthModule>> clientAuthModule;


    public ClientAuthContextType() {
    }

    public ClientAuthContextType(String messageLayer, String appContext, String authenticationContextID, AuthModuleType<ClientAuthModule> clientAuthModule) {
        this.messageLayer = messageLayer;
        this.appContext = appContext;
        this.authenticationContextID = authenticationContextID;
        this.clientAuthModule = Collections.singletonList(clientAuthModule);
    }

    /**
     * Gets the value of the messageLayer property.
     *
     * @return possible object is
     *         {@link String }
     */
    public String getMessageLayer() {
        return messageLayer;
    }

    /**
     * Sets the value of the messageLayer property.
     *
     * @param value allowed object is
     *              {@link String }
     */
    public void setMessageLayer(String value) {
        this.messageLayer = value;
    }

    /**
     * Gets the value of the appContext property.
     *
     * @return possible object is
     *         {@link String }
     */
    public String getAppContext() {
        return appContext;
    }

    /**
     * Sets the value of the appContext property.
     *
     * @param value allowed object is
     *              {@link String }
     */
    public void setAppContext(String value) {
        this.appContext = value;
    }

    /**
     * Gets the value of the authenticationContextID property.
     *
     * @return possible object is
     *         {@link String }
     */
    public String getAuthenticationContextID() {
        return authenticationContextID;
    }

    public String getAuthenticationContextID(MessageInfo messageInfo) {
        return authenticationContextID;
    }

    /**
     * Sets the value of the authenticationContextID property.
     *
     * @param value allowed object is
     *              {@link String }
     */
    public void setAuthenticationContextID(String value) {
        this.authenticationContextID = value;
    }

    /**
     * Gets the value of the clientAuthModule property.
     * <p/>
     * <p/>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the clientAuthModule property.
     * <p/>
     * <p/>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getClientAuthModule().add(newItem);
     * </pre>
     * <p/>
     * <p/>
     * <p/>
     * Objects of the following type(s) are allowed in the list
     * {@link AuthModuleType }
     *
     * @return list of client auth module wrappers
     */
    public List<AuthModuleType<ClientAuthModule>> getClientAuthModule() {
        if (clientAuthModule == null) {
            clientAuthModule = new ArrayList<AuthModuleType<ClientAuthModule>>();
        }
        return this.clientAuthModule;
    }


    public String getKey() {
        return ConfigProviderType.getRegistrationKey(messageLayer, appContext);
    }

    public void initialize(CallbackHandler callbackHandler) throws AuthException {
    }

    public boolean isPersistent() {
        return true;
    }

    public ClientAuthContext newClientAuthContext(CallbackHandler callbackHandler) throws AuthException {
        List<ClientAuthModule> clientAuthModules = new ArrayList<ClientAuthModule>();
        for (AuthModuleType<ClientAuthModule> clientAuthModuleType: clientAuthModule) {
            ClientAuthModule instance = clientAuthModuleType.newAuthModule(callbackHandler);
            clientAuthModules.add(instance);
        }
        return new ClientAuthContextImpl(clientAuthModules);
    }

    public boolean match(String messageLayer, String appContext) {
        if (messageLayer == null) throw new NullPointerException("messageLayer");
        if (appContext == null) throw new NullPointerException("appContext");
        if (messageLayer.equals(this.messageLayer)) {
            return appContext.equals(this.appContext) || this.appContext == null;
        }
        if (this.messageLayer == null) {
            return appContext.equals(this.appContext) || this.appContext == null;
        }
        return false;
    }

    public static class ClientAuthContextImpl implements ClientAuthContext {

        private final List<ClientAuthModule> clientAuthModules;

        public ClientAuthContextImpl(List<ClientAuthModule> clientAuthModules) {
            this.clientAuthModules = clientAuthModules;
        }

        public void cleanSubject(MessageInfo messageInfo, Subject subject) throws AuthException {
            for (ClientAuthModule clientAuthModule : clientAuthModules) {
                clientAuthModule.cleanSubject(messageInfo, subject);
            }
        }

        public AuthStatus secureRequest(MessageInfo messageInfo, Subject clientSubject) throws AuthException {
            for (ClientAuthModule clientAuthModule : clientAuthModules) {
                AuthStatus result = clientAuthModule.secureRequest(messageInfo, clientSubject);

                //jaspi spec p 74
                if (result == AuthStatus.SUCCESS) {
                    continue;
                }
                if (result == AuthStatus.SEND_CONTINUE || result == AuthStatus.FAILURE) {
                    return result;
                }
                throw new AuthException("Invalid AuthStatus " + result + " from client auth module: " + clientAuthModule);
            }
            return AuthStatus.SUCCESS;
        }

        public AuthStatus validateResponse(MessageInfo messageInfo, Subject clientSubject, Subject serviceSubject) throws AuthException {
            for (ClientAuthModule clientAuthModule : clientAuthModules) {
                AuthStatus result = clientAuthModule.validateResponse(messageInfo, clientSubject, serviceSubject);

                //jaspi spec p 74
                if (result == AuthStatus.SUCCESS) {
                    continue;
                }
                if (result == AuthStatus.SEND_CONTINUE || result == AuthStatus.FAILURE) {
                    return result;
                }
                throw new AuthException("Invalid AuthStatus " + result + " from client auth module: " + clientAuthModule);
            }
            return AuthStatus.SUCCESS;
        }
    }

}
